head	1.4;
access;
symbols
	V1_6_7:1.4;
locks; strict;
comment	@# @;


1.4
date	2001.06.26.03.26.03;	author vandys;	state Exp;
branches;
next	1.3;

1.3
date	2001.06.15.08.28.22;	author vandys;	state Exp;
branches;
next	1.2;

1.2
date	2001.06.12.03.33.03;	author vandys;	state Exp;
branches;
next	1.1;

1.1
date	2001.06.12.03.14.05;	author vandys;	state Exp;
branches;
next	;


desc
@A hash-based Dictionary not assuming Magnitude conforming keys.
Also much more efficient for bulk insertion, since it doesn't require
an Array re-copy on each insertion.
@


1.4
log
@Wrap rotor at right time
@
text
@+Set subclass: #Dict
+Dict subclass: #RotorDict variables: #(rotor)
!Dict
at: key ifAbsent: aBlock | pos assoc |
	pos <- self location: key.
	((pos isNil) or: [(assoc <- members at: pos) isNil]) ifTrue: [
		^ aBlock value
	].
	^ assoc value
!
!Dict
at: key put: value | assoc pos |
	" Create the Association "
	assoc <- Association key: key value: value.

	" Insert it using Set's method "
	self add: assoc.

	^ value
!
!Dict
binaryDo: aBlock
	members do: [:assoc|
		assoc notNil ifTrue: [ aBlock value: (assoc key)
			value: (assoc value) ]
	]
!
!Dict
keysDo: aBlock
	members do: [:assoc|
		assoc notNil ifTrue: [ aBlock value: (assoc key) ]
	]
!
!Dict
associationsDo: aBlock
	members do: [:assoc|
		assoc notNil ifTrue: [ aBlock value: assoc ]
	]
!
!Dict
basicDo: aBlock
	^ self associationsDo: aBlock
!
!Dict
keysAsArray | i ret |
	ret <- Array new: self size.
	i <- 1.
	members do: [:assoc| ret at: i put: assoc key. i <- i + 1 ].
	^ ret
!
!Dict
isEmpty
	members do: [:assoc| assoc notNil ifTrue: [ ^ false ]].
	^ true
!
!Dict
do: aBlock
	members do: [:assoc| assoc notNil ifTrue:
		[ aBlock value: (assoc value) ] ]
!
!Dict
removeKey: key ifAbsent: aBlock | assoc |
	assoc <- Association key: key value: nil.
	super remove: assoc ifAbsent: [ ^ aBlock value ].
	^ key
!
!Dict
removeKey: key
	^ self removeKey: key ifAbsent: [ self noElement ]
!
!Dict
remove: value ifAbsent: ignore
	self error: 'Can only remove by key'
!
!RotorDict
rotorDo: aBlock | start lim assoc |
	lim <- members size.
	rotor isNil ifTrue: [ rotor <- 1 ].
	start <- rotor.
	[true] whileTrue: [
		assoc <- members at: rotor.
		rotor <- rotor + 1.
		(rotor > lim) ifTrue: [ rotor <- 1 ].
		assoc notNil ifTrue: [ aBlock value: assoc ].
		(rotor = start) ifTrue: [ ^ self ]
	]
!
!RotorDict
do: aBlock
	^self rotorDo: [:assoc| aBlock value: assoc value]
!
!RotorDict
keysDo: aBlock
	^self rotorDo: [:assoc| aBlock value: assoc key]
!
!RotorDict
binaryDo: aBlock
	^self rotorDo: [:assoc| aBlock value: assoc key value: assoc value]
!
@


1.3
log
@Return block's value
@
text
@a80 1
		(rotor > lim) ifTrue: [ rotor <- 1 ].
d83 1
@


1.2
log
@Rename to Dict rather than "Diction", which is a real word which
doesn't have anything to do with our Dictionary implementation.
Implement RotorDict subclass which remembers where it last left
off in a do: iterator and continues from the next slot.  Useful
for algorithms for data set management which benefit from not always
applying to the lowest member first.
@
text
@d7 1
a7 1
		aBlock value
@


1.1
log
@Initial revision
@
text
@d1 3
a3 3
+Set subclass: #Diction
+IdentitySet subclass: #IdentityDiction
!Diction
d11 1
a11 1
!Diction
d21 1
a21 1
!Diction
d28 1
a28 1
!Diction
d34 1
a34 1
!Diction
d40 1
a40 1
!Diction
d44 1
a44 1
!Diction
d51 1
a51 1
!Diction
d56 1
a56 1
!Diction
d61 1
a61 1
!Diction
d67 1
a67 1
!Diction
d71 1
a71 1
!Diction
d74 25
@
