head	1.20;
access;
symbols
	V1_6_7:1.19;
locks; strict;
comment	@ * @;


1.20
date	2001.09.20.21.17.39;	author vandys;	state Exp;
branches;
next	1.19;

1.19
date	2001.06.15.04.19.00;	author vandys;	state Exp;
branches;
next	1.18;

1.18
date	2001.05.30.00.47.29;	author vandys;	state Exp;
branches;
next	1.17;

1.17
date	2001.05.08.06.46.25;	author vandys;	state Exp;
branches;
next	1.16;

1.16
date	2001.04.04.10.17.27;	author vandys;	state Exp;
branches;
next	1.15;

1.15
date	2001.03.30.11.13.29;	author vandys;	state Exp;
branches;
next	1.14;

1.14
date	2001.03.15.14.54.20;	author vandys;	state Exp;
branches;
next	1.13;

1.13
date	2001.03.13.14.03.31;	author vandys;	state Exp;
branches;
next	1.12;

1.12
date	2001.03.07.21.47.49;	author vandys;	state Exp;
branches;
next	1.11;

1.11
date	2001.03.02.12.09.08;	author vandys;	state Exp;
branches;
next	1.10;

1.10
date	2001.03.01.07.22.36;	author vandys;	state Exp;
branches;
next	1.9;

1.9
date	2001.02.25.21.36.31;	author vandys;	state Exp;
branches;
next	1.8;

1.8
date	2001.02.22.14.52.45;	author vandys;	state Exp;
branches;
next	1.7;

1.7
date	2001.02.14.15.20.46;	author vandys;	state Exp;
branches;
next	1.6;

1.6
date	2001.02.12.23.16.49;	author vandys;	state Exp;
branches;
next	1.5;

1.5
date	2001.02.12.18.07.37;	author vandys;	state Exp;
branches;
next	1.4;

1.4
date	2001.02.11.18.26.46;	author vandys;	state Exp;
branches;
next	1.3;

1.3
date	2001.02.10.18.22.14;	author vandys;	state Exp;
branches;
next	1.2;

1.2
date	2001.02.10.18.14.23;	author vandys;	state Exp;
branches;
next	1.1;

1.1
date	2001.02.10.15.34.12;	author vandys;	state Exp;
branches;
next	;


desc
@@


1.20
log
@Free filePointers[] slot on close()
@
text
@/*
	Little Smalltalk main program, unix version
	Written by Tim Budd, budd@@cs.orst.edu
	All rights reserved, no guarantees given whatsoever.
	May be freely redistributed if not for profit.

	starting point, primitive handler for unix
	version of the little smalltalk system
*/
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <limits.h>
#include <unistd.h>
#if defined(VSTA) && defined(PROFILE)
# include <mcount.h>
#endif
#include "globs.h"

/*
	the following defaults must be set

*/
# define DefaultImageFile "ImageBuilder/image"
# define DefaultStaticSize 40000
# define DefaultDynamicSize 40000
# define DefaultTmpdir "/tmp"

/*
--------------------
*/

# include "memory.h"
# include "interp.h"
# include <stdio.h>

/* # define COUNTTEMPS */

unsigned int debugging = 0, cacheHit = 0, cacheMiss = 0, gccount = 0;
static char *tmpdir = DefaultTmpdir;

void
sysError(char * a, unsigned int b)
{
	fprintf(stderr,"unrecoverable system error: %s 0x%x\n", a, b);
	exit(1);
}

static void
backTrace(struct object * aContext)
{
	printf("back trace\n");
	while (aContext && (aContext != nilObject)) {
		struct object * arguments; int i;
		printf("message %s ", 
			bytePtr(aContext->data[methodInContext]
				->data[nameInMethod]));
		arguments = aContext->data[argumentsInContext];
		if (arguments && (arguments != nilObject)) {
			printf("(");
			for (i = 0; i < SIZE(arguments); i++)
				printf("%s%s", 
				((i == 0) ? "" : ", "),
				bytePtr(arguments->data[i]->class->
					data[nameInClass]));
			printf(")");
			}
		printf("\n");
		aContext = aContext->data[previousContextInContext];
		}
}

# ifdef COUNTTEMPS
FILE * tempFile;
# endif

int
main(int argc, char ** argv)
{
	struct object *aProcess, *aContext, *o;
	int size, i, staticSize, dynamicSize;
	FILE *fp;
	char imageFileName[120], *p;

	strcpy(imageFileName, DefaultImageFile);
	staticSize = DefaultStaticSize;
	dynamicSize = DefaultDynamicSize;

	/*
	 * See if our environment tells us what TMPDIR to use
	 */
	p = getenv("TMPDIR");
	if (p) {
		tmpdir = strdup(p);
	}

	/* first parse arguments */
	for (i = 1; i < argc; i++) {
		if (strcmp(argv[i], "-v") == 0) {
			printf("Little Smalltalk, version 4.01\n");
			}
		else if (strcmp(argv[i], "-s") == 0) {
			staticSize = atoi(argv[++i]);
		} else if (strcmp(argv[i], "-d") == 0) {
			dynamicSize = atoi(argv[++i]);
		} else if (strcmp(argv[i], "-g") == 0) {
			debugging = 1;
		} else {
			strcpy(imageFileName, argv[i]);
			}
		}

# ifdef COUNTTEMPS
	tempFile = fopen("/usr/tmp/counts", "w");
# endif

	gcinit(staticSize, dynamicSize);

	/* read in the method from the image file */
	fp = fopen(imageFileName, "r");
	if (! fp) {
		fprintf(stderr,"cannot open image file: %s\n", imageFileName);
		exit(1);
		}

	printf("%d objects in image\n", fileIn(fp));
	fclose(fp);

	/* build a context around it */

	aProcess = staticAllocate(3);
		/* context should be dynamic */
	aContext = gcalloc(contextSize);
	aContext->class = ContextClass;


	aProcess->data[contextInProcess] = aContext;
	size = integerValue(initialMethod->data[stackSizeInMethod]);
	aContext->data[stackInContext] = staticAllocate(size);
	aContext->data[argumentsInContext] = nilObject;

	aContext->data[temporariesInContext] = staticAllocate(19);
	aContext->data[bytePointerInContext] = newInteger(0);
	aContext->data[stackTopInContext] = newInteger(0);
	aContext->data[previousContextInContext] = nilObject;
	aContext->data[methodInContext] = initialMethod;

	/* now go do it */
	rootStack[rootTop++] = aProcess;

#if defined(VSTA) && defined(PROFILE)
	take_samples(1);
#endif
	switch(execute(aProcess, 0)) {
		case 2: printf("User defined return\n"); break;

		case 3: printf("can't find method in call\n"); 
			aProcess = rootStack[--rootTop];
			o = aProcess->data[resultInProcess];
			printf("Unknown method: %s\n", bytePtr(o));
			aContext = aProcess->data[contextInProcess];
			backTrace(aContext);
			break;

		case 4: printf("\nnormal return\n"); break;

		case 5: printf("time out\n"); break;

		default: printf("unknown return code\n"); break;
	}
#if defined(VSTA) && defined(PROFILE)
	dump_samples();
#endif
	printf("cache hit %u miss %u", cacheHit, cacheMiss);
#define SCALE (1000)
	while ((cacheHit > INT_MAX/SCALE) || (cacheMiss > INT_MAX/SCALE)) {
		cacheHit /= 10;
		cacheMiss /= 10;
	}
	i = (SCALE * cacheHit) / (cacheHit + cacheMiss);
	printf(" ratio %u.%u%%\n", i / 10, i % 10);
	printf("%u garbage collections\n", gccount);
	return(0);
}

/*
	primitive handler
	(note that many primitives are handled in the interpreter)
*/

#define FILEMAX 20
static FILE *filePointers[FILEMAX];

static void
getUnixString(char * to, int size, struct object * from)
{
	int i;
	int fsize = SIZE(from);
	struct byteObject * bobj = (struct byteObject *) from;

	if (fsize > size) {
		sysError("error converting text into unix string", fsize);
	}
	for (i = 0; i < fsize; i++) {
		to[i] = bobj->bytes[i];
	}
	to[i] = '\0';	/* put null terminator at end */
}

struct object *
primitive(int primitiveNumber, struct object *args, int *failed)
{
	struct object *returnedValue = nilObject;
	int i, j;
	FILE *fp;
	char *p;
	struct byteObject *stringReturn;
	char nameBuffer[80], modeBuffer[80];

	*failed = 0;
	switch(primitiveNumber) {
	case 100: 	/* open a file */
		getUnixString(nameBuffer, 80, args->data[0]);
		getUnixString(modeBuffer, 10, args->data[1]);
		fp = fopen(nameBuffer, modeBuffer);
		if (fp != NULL) {
			for (i = 0; i < FILEMAX; ++i) {
				if (filePointers[i] == NULL) {
					break;
				}
			}
			if (i >= FILEMAX) {
				sysError("too many open files", 0);
				fclose(fp);
				*failed = 1;
			} else {
				returnedValue = newInteger(i);
				filePointers[i] = fp;
			}
		} else {
			*failed = 1;
		}
		break;

	case 101:	/* read a single character from a file */
		i = integerValue(args->data[0]);
		if ((i < 0) || (i >= FILEMAX) || !(fp = filePointers[i])) {
			*failed = 1;
			break;
		}
		i = fgetc(fp);
		if (i != EOF) {
			returnedValue = newInteger(i);
		}
		break;

	case 102:	/* write a single character to a file */
		i = integerValue(args->data[0]);
		if ((i < 0) || (i >= FILEMAX) || !(fp = filePointers[i])) {
			*failed = 1;
			break;
		}
		fputc(integerValue(args->data[1]), fp);
		break;

	case 103:	/* close file */
		i = integerValue(args->data[0]);
		if ((i < 0) || (i >= FILEMAX) || !(fp = filePointers[i])) {
			*failed = 1;
			break;
		}
		fclose(fp);
		filePointers[i] = NULL;
		break;

	case 104:	/* file out image */
		i = integerValue(args->data[0]);
		if ((i < 0) || (i >= FILEMAX) || !(fp = filePointers[i])) {
			*failed = 1;
			break;
		}
		fileOut(fp);
		break;

	case 105:	/* edit a string */
			/* first get the name of a temp file */
		sprintf(nameBuffer, "%s/lsteditXXXXXX", tmpdir);
		mktemp(nameBuffer);
			/* copy string to file */
		fp = fopen(nameBuffer, "w");
		if (fp == NULL) 
			sysError("cannot open temp edit file", 0);
		j = SIZE(args->data[0]);
		p = ((struct byteObject *) args->data[0])->bytes;
		for (i = 0; i < j; i++)
			fputc(*p++, fp);
		fputc('\n', fp);
		fclose(fp);
			/* edit string */
		strcpy(modeBuffer,"vi ");
		strcat(modeBuffer,nameBuffer);
		system(modeBuffer);
			/* copy back to new string */
		fp = fopen(nameBuffer, "r");
		if (fp == NULL) 
			sysError("cannot open temp edit file", 0);
			/* get length of file */
		fseek(fp, 0, 2);
		j = (int) ftell(fp);
		returnedValue = 
			(struct object *) stringReturn = gcialloc(j);
		returnedValue->class = args->data[0]->class;
			/* reset to beginning, and read values */
		fseek(fp, 0, 0);
		for (i = 0; i < j; i++)
			stringReturn->bytes[i] = fgetc(fp);
			/* now clean up files */
		fclose(fp);
		unlink(nameBuffer);
		break;

	case 106:	/* Read into ByteArray */
		/* File descriptor */
		i = integerValue(args->data[0]);
		if ((i < 0) || (i >= FILEMAX) || !(fp = filePointers[i])) {
			*failed = 1;
			break;
		}

		/* Make sure we're populating an array of bytes */
		returnedValue = args->data[1];
		if ((returnedValue->size & FLAG_BIN) == 0) {
			*failed = 1;
			break;
		}

		/* Sanity check on I/O count */
		i = integerValue(args->data[2]);
		if ((i < 0) || (i > SIZE(returnedValue))) {
			*failed = 1;
			break;
		}

		/* Do the I/O */
		i = fread(bytePtr(returnedValue), sizeof(char), i, fp);
		if (i < 0) {
			*failed = 1;
			break;
		}
		returnedValue = newInteger(i);
		break;

	case 107:	/* Write from ByteArray */
		/* File descriptor */
		i = integerValue(args->data[0]);
		if ((i < 0) || (i >= FILEMAX) || !(fp = filePointers[i])) {
			*failed = 1;
			break;
		}

		/* Make sure we're writing an array of bytes */
		returnedValue = args->data[1];
		if ((returnedValue->size & FLAG_BIN) == 0) {
			*failed = 1;
			break;
		}

		/* Sanity check on I/O count */
		i = integerValue(args->data[2]);
		if ((i < 0) || (i > SIZE(returnedValue))) {
			*failed = 1;
			break;
		}

		/* Do the I/O */
		i = fwrite(bytePtr(returnedValue), sizeof(char), i, fp);
		if (i < 0) {
			*failed = 1;
			break;
		}
		returnedValue = newInteger(i);
		break;

	case 108:	/* Seek to file position */
		/* File descriptor */
		i = integerValue(args->data[0]);
		if ((i < 0) || (i >= FILEMAX) || !(fp = filePointers[i])) {
			*failed = 1;
			break;
		}

		/* File position */
		i = integerValue(args->data[1]);
		if ((i < 0) || ((i = fseek(fp, i, SEEK_SET)) < 0)) {
			*failed = 1;
			break;
		}

		/* Return position as our value */
		returnedValue = newInteger(i);
		break;

	default:
		sysError("unknown primitive", primitiveNumber);
	}
	return(returnedValue);
}
@


1.19
log
@Implement random file I/O
@
text
@d273 1
@


1.18
log
@Use new primitive failure path for File I/O.
Remove an old VSTa hack from main().
@
text
@d14 1
d49 2
a50 1
void backTrace(struct object * aContext)
d191 2
a192 3
# define FILEMAX 10
FILE * filePointers[FILEMAX];
int fileTop = 0;
d194 1
a194 1
void
d201 4
a204 3
	if (fsize > size) sysError("error converting text into unix string",
		fsize);
	for (i = 0; i < fsize; i++)
d206 1
d215 3
a217 3
	FILE * fp;
	char * p;
	struct byteObject * stringReturn;
d227 6
a232 1
			if (fileTop + 1 >= FILEMAX) {
d237 2
a238 2
				returnedValue = newInteger(fileTop);
				filePointers[fileTop++] = fp;
a245 4
		if (!IS_SMALLINT(args->data[0])) {
			*failed = 1;
			break;
		}
d247 1
a247 1
		if ((i < 0) || (i >= FILEMAX)) {
d251 1
a251 1
		i = fgetc(filePointers[i]);
a257 5
		if (!IS_SMALLINT(args->data[0])
				|| !IS_SMALLINT(args->data[1])) {
			*failed = 1;
			break;
		}
d259 1
a259 1
		if ((i < 0) || (i >= FILEMAX)) {
d263 1
a263 1
		fputc(integerValue(args->data[1]), filePointers[i]);
a266 4
		if (!IS_SMALLINT(args->data[0])) {
			*failed = 1;
			break;
		}
d268 1
a268 1
		if ((i < 0) || (i >= FILEMAX)) {
d272 1
a272 4
		fclose(filePointers[i]);
		if (i+1 == fileTop) {
			fileTop--;
		}
d277 5
a281 1
		fileOut(filePointers[i]);
d319 81
@


1.17
log
@Parameterize use of object "size" field
@
text
@a82 3
#if defined(VSTA) && defined(DEBUG)
	notify_handler(NULL);
#endif
d208 1
a208 1
primitive(int primitiveNumber, struct object * args)
d217 1
d226 5
d232 2
a233 2
			returnedValue = newInteger(fileTop);
			filePointers[fileTop++] = fp;
d239 1
d244 1
d256 1
d261 1
d269 1
d274 1
d328 1
a328 1
	return returnedValue;
@


1.16
log
@Infrastructure for debugging
@
text
@d59 1
a59 1
			for (i = 0; i < (arguments->size >> 2); i++)
d200 1
a200 1
	int fsize = from->size >> 2;
d287 1
a287 1
		j = args->data[0]->size >> 2;
@


1.15
log
@Range check on file ID
@
text
@d155 1
a155 1
	switch(execute(aProcess)) {
@


1.14
log
@VSTa CPU profiling
@
text
@d213 1
a213 1
	struct object * returnedValue = nilObject;
d235 3
d239 3
d249 9
a257 2
		fputc(integerValue(args->data[1]),
			filePointers[integerValue(args->data[0])]);
d261 3
d265 3
@


1.13
log
@For VSTa, make segv debugging easier
@
text
@d14 3
d152 3
d171 4
a174 1
		}
@


1.12
log
@Implement SmallInt's as pseudo-objects.  They are 31-bit
signed quantities; the object pointer's low bit is set to 1
to flag a SmallInt as opposed to a true memory-based object
pointer.
@
text
@d80 3
@


1.11
log
@Renumber system primitives
@
text
@a44 23
struct object *
nwInteger(unsigned int v)
{
	register struct integerObject * n;

	if (v < 10)
		return smallInts[v];
	n = (struct integerObject *) gcialloc(BytesPerWord);
	n->class = SmallIntClass;
	n->value = v;
	return (struct object *) n;
}

struct object * staticInteger(int v)
{
	struct integerObject * n;

	n = (struct integerObject *) staticIAllocate(BytesPerWord);
	n->class = SmallIntClass;
	n->value = v;
	return (struct object *) n;
}

d138 2
a139 2
	aContext->data[bytePointerInContext] = staticInteger(0);
	aContext->data[stackTopInContext] = staticInteger(0);
d217 1
a217 1
			returnedValue = nwInteger(fileTop);
d226 1
a226 1
			returnedValue = nwInteger(i);
@


1.10
log
@Fix hit percentage integer method for case where integers get
rather large.
@
text
@d232 1
a232 1
	case 30: 	/* open a file */
d245 1
a245 1
	case 31:	/* read a single character from a file */
d253 1
a253 1
	case 32:	/* write a single character to a file */
d258 1
a258 1
	case 33:	/* close file */
d266 1
a266 1
	case 34:	/* file out image */
d271 1
a271 1
	case 35:	/* edit a string */
@


1.9
log
@Use hex for displaying addresses
@
text
@d13 1
d35 1
a35 4
int debugging = 0;
int cacheHit = 0;
int cacheMiss = 0;
int gccount = 0;
d186 9
a194 4
	i = (1000 * cacheHit) / (cacheHit + cacheMiss);
	printf("cache hit %d miss %d ratio %d.%d%%\n",
		cacheHit, cacheMiss, i / 10, i % 10);
	printf("%d garbage collections\n", gccount);
@


1.8
log
@For debugging, force a raw OS exit on SEGV's
@
text
@d41 1
a41 1
sysError(char * a, int b)
d43 1
a43 1
	fprintf(stderr,"unrecoverable system error: %s %d\n", a, b);
a104 1
	notify_handler(NULL);
@


1.7
log
@Honor TMPDIR from the environment, if it's present
@
text
@d105 1
@


1.6
log
@Fix -Wall
@
text
@d22 1
d38 1
d40 2
a41 1
void sysError(char * a, int b)
d47 2
a48 1
struct object * nwInteger(unsigned int v)
d103 1
a103 1
	char imageFileName[120];
d109 8
d218 4
a221 2
struct object * primitive(int primitiveNumber, struct object * args)
{	struct object * returnedValue = nilObject;
d226 1
a226 2
	char nameBuffer[80];
	char modeBuffer[80];
d229 12
a240 11
		case 30: 	/* open a file */
			getUnixString(nameBuffer, 80, args->data[0]);
			getUnixString(modeBuffer, 10, args->data[1]);
			fp = fopen(nameBuffer, modeBuffer);
			if (fp != NULL) {
				if (fileTop + 1 >= FILEMAX)
					sysError("too many open files", 0);
				returnedValue = nwInteger(fileTop);
				filePointers[fileTop++] = fp;
				}
			break;
d242 7
a248 6
		case 31:	/* read a single character from a file */
			i = integerValue(args->data[0]);
			i = fgetc(filePointers[i]);
			if (i != EOF)
				returnedValue = nwInteger(i);
			break;
d250 12
a261 53
		case 32:	/* write a single character to a file */
			fputc(integerValue(args->data[1]),
				filePointers[integerValue(args->data[0])]);
			break;

		case 33:	/* close file */
			i = integerValue(args->data[0]);
			fclose(filePointers[i]);
			if (i+1 == fileTop)
				fileTop--;
			break;

		case 34:	/* file out image */
			i = integerValue(args->data[0]);
			fileOut(filePointers[i]);
			break;

		case 35:	/* edit a string */
				/* first get the name of a temp file */
			strcpy(nameBuffer, "/usr/tmp/lsteditXXXXXX");
			mktemp(nameBuffer);
				/* copy string to file */
			fp = fopen(nameBuffer, "w");
			if (fp == NULL) 
				sysError("cannot open temp edit file", 0);
			j = args->data[0]->size >> 2;
			p = ((struct byteObject *) args->data[0])->bytes;
			for (i = 0; i < j; i++)
				fputc(*p++, fp);
			fputc('\n', fp);
			fclose(fp);
				/* edit string */
			strcpy(modeBuffer,"vi ");
			strcat(modeBuffer,nameBuffer);
			system(modeBuffer);
				/* copy back to new string */
			fp = fopen(nameBuffer, "r");
			if (fp == NULL) 
				sysError("cannot open temp edit file", 0);
				/* get length of file */
			fseek(fp, 0, 2);
			j = (int) ftell(fp);
			returnedValue = 
				(struct object *) stringReturn = gcialloc(j);
			returnedValue->class = args->data[0]->class;
				/* reset to beginning, and read values */
			fseek(fp, 0, 0);
			for (i = 0; i < j; i++)
				stringReturn->bytes[i] = fgetc(fp);
				/* now clean up files */
			fclose(fp);
			unlink(nameBuffer);
			break;
d263 45
a307 3
		default:
			sysError("unknown primitive", primitiveNumber);
		}
@


1.5
log
@Use ImageBuilder image.
Turn on debugging from the get-go if "-g"
@
text
@d10 4
@


1.4
log
@Try to provide a little more detail on missing method lookup
@
text
@d15 1
a15 1
# define DefaultImageFile "image"
d110 2
@


1.3
log
@Get rid of only floating point math... use integer technique instead.
Provide return value for main()
@
text
@d15 1
a15 1
# define DefaultImageFile "LittleSmalltalkImage"
d92 2
a93 4
	struct object *aProcess;
	struct object *aContext;
	int size, i;
	int staticSize, dynamicSize;
d158 2
@


1.2
log
@Fix up initial context so backtrace doesn't crash on illegal
fields.
@
text
@d74 2
a75 1
				printf("%s,", 
d170 3
a172 2
	printf("cache hit %d miss %d ratio %f\%\n", cacheHit, cacheMiss,
		100.0 * ((double) cacheHit) / ((double) cacheHit + cacheMiss));
d174 1
@


1.1
log
@Initial revision
@
text
@d88 5
a92 4
main(int argc, char ** argv) {

	struct object * aProcess;
	struct object * aContext;
d95 1
a95 1
	FILE * fp;
d109 1
a109 2
			}
		else if (strcmp(argv[i], "-d") == 0) {
d111 1
a111 2
			}
		else {
d137 1
a141 1
	aContext->data[argumentsInContext] = staticAllocate(2);
d143 1
a143 1
	aContext->data[argumentsInContext] = staticAllocate(2);
d183 2
a184 1
void getUnixString(char * to, int size, struct object * from)
@
