head	1.18;
access;
symbols
	V1_6_7:1.18;
locks; strict;
comment	@ * @;


1.18
date	2001.05.29.01.14.08;	author vandys;	state Exp;
branches;
next	1.17;

1.17
date	2001.05.29.00.37.18;	author vandys;	state Exp;
branches;
next	1.16;

1.16
date	2001.05.29.00.28.20;	author vandys;	state Exp;
branches;
next	1.15;

1.15
date	2001.05.08.06.46.25;	author vandys;	state Exp;
branches;
next	1.14;

1.14
date	2001.03.16.11.38.03;	author vandys;	state Exp;
branches;
next	1.13;

1.13
date	2001.03.16.10.32.29;	author vandys;	state Exp;
branches;
next	1.12;

1.12
date	2001.03.15.16.26.14;	author vandys;	state Exp;
branches;
next	1.11;

1.11
date	2001.03.13.22.08.33;	author vandys;	state Exp;
branches;
next	1.10;

1.10
date	2001.03.07.23.15.08;	author vandys;	state Exp;
branches;
next	1.9;

1.9
date	2001.03.07.21.47.49;	author vandys;	state Exp;
branches;
next	1.8;

1.8
date	2001.03.03.15.38.10;	author vandys;	state Exp;
branches;
next	1.7;

1.7
date	2001.03.01.07.23.10;	author vandys;	state Exp;
branches;
next	1.6;

1.6
date	2001.02.28.06.33.17;	author vandys;	state Exp;
branches;
next	1.5;

1.5
date	2001.02.28.06.27.53;	author vandys;	state Exp;
branches;
next	1.4;

1.4
date	2001.02.26.21.06.46;	author vandys;	state Exp;
branches;
next	1.3;

1.3
date	2001.02.25.21.37.01;	author vandys;	state Exp;
branches;
next	1.2;

1.2
date	2001.02.12.23.16.49;	author vandys;	state Exp;
branches;
next	1.1;

1.1
date	2001.02.10.15.34.12;	author vandys;	state Exp;
branches;
next	;


desc
@@


1.18
log
@Convert missing method to a call to doesNotUnderstand:
This creates the possibility of intercepting this message by a debugger
or proxy object.
@
text
@/*
	Little Smalltalk memory management
	Written by Tim Budd, budd@@cs.orst.edu
	All rights reserved, no guarantees given whatsoever.
	May be freely redistributed if not for profit.

	Uses baker two-space garbage collection algorithm
*/

# include <stdio.h>
# include <stdlib.h>
# include "memory.h"
# include "globs.h"

extern int debugging;	/* true if we are debugging */

/*
	static memory space -- never recovered
*/
static struct object *staticBase, *staticTop, *staticPointer;

/*
	dynamic (managed) memory space
	recovered using garbage collection
*/

static struct object *spaceOne, *spaceTwo;
static int spaceSize;

struct object *memoryBase, *memoryPointer, *memoryTop;

static int inSpaceOne;
static struct object *oldBase, *oldTop;

/*
	roots for memory access
	used as bases for garbage collection algorithm
*/
struct object *rootStack[ROOTSTACKLIMIT];
int rootTop = 0;
#define STATICROOTLIMIT (200)
static struct object **staticRoots[STATICROOTLIMIT];
static int staticRootTop = 0;

/*
	test routine to see if a pointer is in dynamic memory
	area or not
*/

int
isDynamicMemory(struct object * x)
{
	return ((x >= spaceOne) && (x <= (spaceOne + spaceSize))) ||
		((x >= spaceTwo) && (x <= (spaceTwo + spaceSize)));
}

/*
	gcinit -- initialize the memory management system
*/
void
gcinit(int staticsz, int dynamicsz)
{
		/* allocate the memory areas */
	staticBase = (struct object *)
		malloc(staticsz * sizeof(struct object));
	spaceOne = (struct object *)
		malloc(dynamicsz * sizeof(struct object));
	spaceTwo = (struct object *)
		malloc(dynamicsz * sizeof(struct object));
	if ((staticBase == 0) || (spaceOne == 0) || (spaceTwo == 0))
		sysError("not enough memory for space allocations\n", 0);

	staticTop = staticBase + staticsz;
	staticPointer = staticTop;

	spaceSize = dynamicsz;
	memoryBase = spaceOne;
	memoryPointer = memoryBase + spaceSize;
	if (debugging) {
		printf("space one 0x%x, top 0x%x,"
				" space two 0x%x , top 0x%x\n",
			(uint)spaceOne, (uint)(spaceOne + spaceSize),
			(uint)spaceTwo, (uint)(spaceTwo + spaceSize));
	}
	inSpaceOne = 1;
}

/*
	gc_move is the heart of the garbage collection algorithm.
	It takes as argument a pointer to a value in the old space,
	and moves it, and everything it points to, into the new space
	The returned value is the address in the new space.
*/
struct mobject {
	uint size;
	struct mobject *data[0];
};

static struct object *
gc_move(struct mobject * ptr)
{
	struct mobject *old_address = ptr, *previous_object = 0,
		*new_address = 0, *replacement  = 0;
	int sz;

	while (1) {

		/*
		 * part 1.  Walking down the tree
		 * keep stacking objects to be moved until we find
		 * one that we can handle
		 */
		for (;;) {
			/*
			 * SmallInt's are not proper memory pointers,
			 * so catch them first.  Their "object pointer"
			 * value can be used as-is in the new space.
			 */
			if (IS_SMALLINT(old_address)) {
				replacement = old_address;
				old_address = previous_object;
				break;

			/*
			 * If we find a pointer in the current space
			 * to the new space (other than indirections) then
			 * something is very wrong
			 */
			} else if ((old_address >=
			 (struct mobject *) memoryBase)
			 && (old_address <= (struct mobject *) memoryTop)) {
				sysError(
				 "GC invariant failure -- address in new space",
					(unsigned int)old_address);

			/* else see if not  in old space */
			} else if ((old_address < (struct mobject *) oldBase) ||
			 (old_address > (struct mobject *) oldTop)) {
				replacement = old_address;
				old_address = previous_object;
				break;

			/* else see if already forwarded */
			} else if (old_address->size & FLAG_GCDONE)  {
				if (old_address->size & FLAG_BIN) {
					replacement = old_address->data[0];
				} else {
					sz = SIZE(old_address);
					replacement = old_address->data[sz];
				}
				old_address = previous_object;
				break;

			/* else see if binary object */
			} else if (old_address->size & FLAG_BIN) {
				int isz;

				isz = SIZE(old_address);
				sz = (isz + BytesPerWord - 1)/BytesPerWord;
				memoryPointer = WORDSDOWN(memoryPointer,
					sz + 2);
				new_address = (struct mobject *)memoryPointer;
				SETSIZE(new_address, isz);
				new_address->size |= FLAG_BIN;
				while (sz) {
					new_address->data[sz] =
						old_address->data[sz];
					sz--;
				}
				old_address->size |= FLAG_GCDONE;
				new_address->data[0] = previous_object;
				previous_object = old_address;
				old_address = old_address->data[0];
				previous_object->data[0] = new_address;
				/* now go chase down class pointer */

			/* must be non-binary object */
			} else  {
				sz = SIZE(old_address);
				memoryPointer = WORDSDOWN(memoryPointer,
					sz + 2);
				new_address = (struct mobject *)memoryPointer;
				SETSIZE(new_address, sz);
				old_address->size |= FLAG_GCDONE;
				new_address->data[sz] = previous_object;
				previous_object = old_address;
				old_address = old_address->data[sz];
				previous_object->data[sz] = new_address;
			}
		}

		/*
		 * part 2.  Fix up pointers,
		 * move back up tree as long as possible
		 * old_address points to an object in the old space,
		 * which in turns points to an object in the new space,
		 * which holds a pointer that is now to be replaced.
		 * the value in replacement is the new value
		 */
		for (;;) {
			/* backed out entirely */
			if (old_address == 0) {
				return (struct object *) replacement;
			}

			/* case 1, binary or last value */
			if ((old_address->size & FLAG_BIN) ||
			 (SIZE(old_address) == 0)) {

				/* fix up class pointer */
				new_address = old_address->data[0];
				previous_object = new_address->data[0];
				new_address->data[0] = replacement;
				old_address->data[0] = new_address;
				replacement = new_address;
				old_address = previous_object;
			} else {
				sz = SIZE(old_address);
				new_address = old_address->data[sz];
				previous_object = new_address->data[sz];
				new_address->data[sz] = replacement;
				sz--;

				/*
				 * quick cheat for recovering zero fields
				 */
				while (sz && (old_address->data[sz] == 0)) {
					new_address->data[sz--] = 0;
				}

				SETSIZE(old_address, sz);
				old_address->size |= FLAG_GCDONE;
				new_address->data[sz] = previous_object;
				previous_object = old_address;
				old_address = old_address->data[sz];
				previous_object->data[sz] = new_address;
				break; /* go track down this value */
			}
		}
	}
}

/*
	gcollect -- garbage collection entry point
*/
extern int gccount;
struct object *
gcollect(int sz)
{
	int i;

	gccount++;

	/* first change spaces */
	if (inSpaceOne) {
		memoryBase = spaceTwo;
		inSpaceOne = 0;
		oldBase = spaceOne;
	} else {
		memoryBase = spaceOne;
		inSpaceOne = 1;
		oldBase = spaceTwo;
	}
	memoryPointer = memoryTop = memoryBase + spaceSize;
	oldTop = oldBase + spaceSize;

	/* then do the collection */
	for (i = 0; i < rootTop; i++) {
		rootStack[i] = gc_move((struct mobject *) rootStack[i]);
	}
	for (i = 0; i < staticRootTop; i++) {
		(* staticRoots[i]) =  gc_move((struct mobject *)
			*staticRoots[i]);
	}

	flushCache();

	/* then see if there is room for allocation */
	memoryPointer = WORDSDOWN(memoryPointer, sz + 2);
	if (memoryPointer < memoryBase) {
		sysError("insufficient memory after garbage collection", sz);
	}
	SETSIZE(memoryPointer, sz);
	return(memoryPointer);
}

/*
	static allocation -- tries to allocate values in an area
	that will not be subject to garbage collection
*/

struct object *
staticAllocate(int sz)
{
	staticPointer = WORDSDOWN(staticPointer, sz + 2);
	if (staticPointer < staticBase) {
		sysError("insufficient static memory", 0);
	}
	SETSIZE(staticPointer, sz);
	return(staticPointer);
}

struct object *
staticIAllocate(int sz)
{
	int trueSize;
	struct object * result;

	trueSize = (sz + BytesPerWord - 1) / BytesPerWord;
	result = staticAllocate(trueSize);
	SETSIZE(result, sz);
	result->size |= FLAG_BIN;
	return result;
}

/*
	if definition is not in-lined, here  is what it should be
*/
#ifndef gcalloc
struct object *
gcalloc(int sz)
{
	struct object * result;

	memoryPointer = WORDSDOWN(memoryPointer, sz + 2);
	if (memoryPointer < memoryBase) {
		return gcollect(sz);
	}
	SETSIZE(memoryPointer, sz);
	return(memoryPointer);
}
# endif

struct object *
gcialloc(int sz)
{
	int trueSize;
	struct object * result;

	trueSize = (sz + BytesPerWord - 1) / BytesPerWord;
	result = gcalloc(trueSize);
	SETSIZE(result, sz);
	result->size |= FLAG_BIN;
	return result;
}

/*
	File in and file out of Smalltalk images
*/

static int indirtop = 0;
static struct object **indirArray;

static unsigned int
readWord(FILE * fp)
{
	int i;

	i = fgetc(fp);
	if (i == EOF) {
		sysError("unexpected end of file reading image file", 0);
	}
	if (i == 255) {
		return 255 + readWord(fp);
	} else {
		return i;
	}
}

static struct object *
objectRead(FILE * fp)
{
	int type, size, i;
	struct object *newObj = 0;
	struct byteObject *bnewObj;

	type = readWord(fp);

	switch (type) {
		case 0:	/* nil obj */
			sysError("read in a null object", (int)newObj);

		case 1:	/* ordinary object */
			size = readWord(fp);
			newObj = staticAllocate(size);
			indirArray[indirtop++] = newObj;
			newObj->class = objectRead(fp);
			for (i = 0; i < size; i++) {
				newObj->data[i] = objectRead(fp);
				}
			break;

		case 2: /* integer */
			{
			int val;

			(void)fread(&val, sizeof(val), 1, fp);
			newObj = newInteger(val);
			}
			break;

		case 3:	/* byte arrays */
			size = readWord(fp);
			newObj = staticIAllocate(size);
			indirArray[indirtop++] = newObj;
			bnewObj = (struct byteObject *) newObj;
			for (i = 0; i < size; i++) {
				type = readWord(fp);
				bnewObj->bytes[i] = type;
				}
			bnewObj->class = objectRead(fp);
			break;

		case 4:	/* previous object */
			size = readWord(fp);
			newObj = indirArray[size];
			break;

		case 5:	/* object 0 (nil object) */
			newObj = indirArray[0];
			break;
		}
	return newObj;
}


int
fileIn(FILE * fp)
{
	int i;

	/* use the currently unused space for the indir pointers */
	if (inSpaceOne) {
		indirArray = (struct object * *) spaceTwo;
	} else {
		indirArray = (struct object * *) spaceOne;
	}
	indirtop = 0;

	/* read in the method from the image file */
	nilObject = objectRead(fp);
	trueObject = objectRead(fp);
	falseObject = objectRead(fp);
	globalsObject = objectRead(fp);
	SmallIntClass = objectRead(fp);
	IntegerClass = objectRead(fp);
	ArrayClass = objectRead(fp);
	BlockClass = objectRead(fp);
	ContextClass = objectRead(fp);
	initialMethod = objectRead(fp);
	for (i = 0; i < 3; i++) {
		binaryMessages[i] = objectRead(fp);
	}
	badMethodSym = objectRead(fp);

	/* clean up after ourselves */
	bzero((char *) indirArray, spaceSize * sizeof(struct object));
	return indirtop;
}

static void
writeWord(FILE * fp, int i)
{
	if (i < 0) {
		sysError("trying to write out negative value", i);
	}
	if (i >= 255) {
		fputc(255, fp);
		writeWord(fp, i - 255);
	} else {
		fputc(i, fp);
	}
}

static void
objectWrite(FILE *fp, struct object * obj)
{
	int i, size;

	if (obj == 0) {
		sysError("writing out a null object", (int)obj);
	}

	if (IS_SMALLINT(obj)) { /* SmallInt */
		int val;

		writeWord(fp, 2);
		val = integerValue(obj);
		(void)fwrite(&val, sizeof(val), 1, fp);
		return;
	}

	/* see if already written */
	for (i = 0; i < indirtop; i++) {
		if (obj == indirArray[i]) {
			if (i == 0) {
				writeWord(fp, 5);
			} else {
				writeWord(fp, 4);
				writeWord(fp, i);
			}
			return;
		}
	}

	/* not written, do it now */
	indirArray[indirtop++] = obj;

	/* byte objects */
	if (obj->size & FLAG_BIN) {
		struct byteObject * bobj = (struct byteObject *) obj;
		size = SIZE(obj);
		writeWord(fp, 3);
		writeWord(fp, size);
		for (i = 0; i < size; i++)
			writeWord(fp, bobj->bytes[i]);
		objectWrite(fp, obj->class);
		return;
	}

	/* ordinary objects */
	size = SIZE(obj);
	writeWord(fp, 1);
	writeWord(fp, size);
	objectWrite(fp, obj->class);
	for (i = 0; i < size; i++) {
		objectWrite(fp, obj->data[i]);
	}
}

int
fileOut(FILE * fp)
{
	int i;

	/* use the currently unused space for the indir pointers */
	if (inSpaceOne) {
		indirArray = (struct object * *) spaceTwo;
	} else {
		indirArray = (struct object * *) spaceOne;
	}
	indirtop = 0;

	/* write out the roots of the image file */
	objectWrite(fp, nilObject);
	objectWrite(fp, trueObject);
	objectWrite(fp, falseObject);
	objectWrite(fp, globalsObject);
	objectWrite(fp, SmallIntClass);
	objectWrite(fp, IntegerClass);
	objectWrite(fp, ArrayClass);
	objectWrite(fp, BlockClass);
	objectWrite(fp, ContextClass);
	objectWrite(fp, initialMethod);
	for (i = 0; i < 3; i++) {
		objectWrite(fp, binaryMessages[i]);
	}
	objectWrite(fp, badMethodSym);
	printf("%d objects written in image\n", indirtop);

	/* clean up after ourselves */
	bzero((char *) indirArray, spaceSize * sizeof(struct object));
	return indirtop;
}

/*
 * addStaticRoot()
 *	Add another object root off a static object
 *
 * Static objects, in general, do not get garbage collected.  When
 * a static object is discovered adding a reference to a non-static
 * object, we link on the reference to our staticRoot table so we can
 * give it proper treatment during garbage collection.
 */
void
addStaticRoot(struct object **objp)
{
	int i;

	for (i = 0; i < staticRootTop; ++i) {
		if (objp == staticRoots[i]) {
			return;
		}
	}
	if (staticRootTop >= STATICROOTLIMIT) {
		sysError("addStaticRoot: too many static references",
			(unsigned int)objp);
	}
	staticRoots[staticRootTop++] = objp;
}

/*
 * map()
 *	Fix an OOP if needed, based on values to be exchanged
 */
static void
map(struct object **oop, struct object *a1, struct object *a2, int size)
{
	int x;
	struct object *oo = *oop;

	for (x = 0; x < size; ++x) {
		if (a1->data[x] == oo) {
			*oop = a2->data[x];
			return;
		}
		if (a2->data[x] == oo) {
			*oop = a1->data[x];
			return;
		}
	}
}

/*
 * walk()
 *	Traverse an object space
 */
static void
walk(struct object *base, struct object *top,
	struct object *array1, struct object *array2, uint size)
{
	struct object *op, *opnext;
	uint x, sz;

	for (op = base; op < top; op = opnext) {
		/*
		 * Re-map the class pointer, in case that's the
		 * object which has been remapped.
		 */
		map(&op->class, array1, array2, size);

		/*
		 * Skip our argument arrays, since otherwise things
		 * get rather circular.
		 */
		sz = SIZE(op);
		if ((op == array1) || (op == array2)) {
			opnext = WORDSUP(op, sz + 2);
			continue;
		}

		/*
		 * Don't have to worry about instance variables
		 * if it's a binary format.
		 */
		if (op->size & FLAG_BIN) {
			uint trueSize;

			/*
			 * Skip size/class, and enough words to
			 * contain the binary bytes.
			 */
			trueSize = (sz + BytesPerWord - 1) / BytesPerWord;
			opnext = WORDSUP(op, trueSize + 2);
			continue;
		}

		/*
		 * For each instance variable slot, fix up the pointer
		 * if needed.
		 */
		for (x = 0; x < sz; ++x) {
			map(&op->data[x], array1, array2, size);
		}

		/*
		 * Walk past this object
		 */
		opnext = WORDSUP(op, sz + 2);
	}
}

/*
 * exchangeObjects()
 *	Bulk exchange of object identities
 *
 * For each index to array1/array2, all references in current object
 * memory are modified so that references to the object in array1[]
 * become references to the corresponding object in array2[].  References
 * to the object in array2[] similarly become references to the
 * object in array1[].
 */
void
exchangeObjects(struct object *array1, struct object *array2, uint size)
{
	uint x;

	/*
	 * Convert our memory spaces
	 */
	walk(memoryPointer, memoryTop, array1, array2, size);
	walk(staticPointer, staticTop, array1, array2, size);

	/*
	 * Fix up the root pointers, too
	 */
	for (x = 0; x < rootTop; x++) {
		map(&rootStack[x], array1, array2, size);
	}
	for (x = 0; x < staticRootTop; x++) {
		map(staticRoots[x], array1, array2, size);
	}
}
@


1.17
log
@Handle static space and object roots, too
@
text
@d454 1
d558 1
@


1.16
log
@Implement become:
Also tidy up some pointer arithmetic idioms using a macro
@
text
@d613 2
a614 8
 * exchangeObjects()
 *	Bulk exchange of object identities
 *
 * For each index to array1/array2, all references in current object
 * memory are modified so that references to the object in array1[]
 * become references to the corresponding object in array2[].  References
 * to the object in array2[] similarly become references to the
 * object in array1[].
d616 3
a618 2
void
exchangeObjects(struct object *array1, struct object *array2, uint size)
d623 1
a623 1
	for (op = memoryPointer; op < memoryTop; op = opnext) {
d668 32
@


1.15
log
@Parameterize use of object "size" field
@
text
@d160 2
a161 2
				memoryPointer = (struct object *)(
				 ((uint *)memoryPointer) - (sz + 2));
d180 2
a181 2
				memoryPointer = (struct object *)(
				 ((uint *)memoryPointer) - (sz + 2));
d279 1
a279 2
	memoryPointer = (struct object *)
	 (((uint *)memoryPointer) - (sz + 2));
d295 1
a295 2
	staticPointer = (struct object *)
		(((uint *)staticPointer) - (sz + 2));
d325 1
a325 2
	memoryPointer = (struct object *)
		(((uint *)memoryPointer) - (sz + 2));
d588 86
@


1.14
log
@Remove need for bulk bzero() of spaces during GC setup.  Zero
fields as needed instead.
@
text
@d95 2
a96 2
	int size;
	struct mobject * data [0];
d144 2
a145 2
			} else if (old_address->size & 01)  {
				if (old_address->size & 02) {
d148 1
a148 1
					sz = old_address->size >> 2;
d155 1
a155 1
			} else if (old_address->size & 02) {
d158 1
a158 1
				isz = old_address->size >> 2;
d163 2
a164 1
				new_address->size = (isz << 2) | 02;
d170 1
a170 1
				old_address->size |= 01;
d179 1
a179 1
				sz = old_address->size >> 2;
d183 2
a184 2
				new_address->size = (sz << 2);
				old_address->size |= 01;
d207 2
a208 2
			if ((old_address->size & 02) ||
			 ((old_address->size>>2) == 0)) {
d218 1
a218 1
				sz = old_address->size >> 2;
d231 2
a232 1
				old_address->size = (sz << 2) | 01;
d284 1
a284 1
	memoryPointer->size = sz << 2;
d301 1
a301 1
	staticPointer->size = sz << 2;
d313 2
a314 1
	result->size = (sz << 2) | 02;
d332 1
a332 1
	memoryPointer->size = sz << 2;
d345 2
a346 1
	result->size = (sz << 2) | 02;
d512 1
a512 1
	if (obj->size & 02) {
d514 1
a514 1
		size = obj->size >> 2;
d524 1
a524 1
	size = obj->size >> 2;
@


1.13
log
@Fix pointer arithmetic error, where object sizes were being scaled
by sizeof(struct object), wasting a lot of memory.
@
text
@d227 1
a227 1
					sz--;
d251 1
a262 1
	bzero((char *) memoryBase, spaceSize * sizeof(struct object));
d271 1
a271 1
			* staticRoots[i]);
@


1.12
log
@Avoid C pointer scaling when doing straight word quantity
allocations.
@
text
@d229 1
d277 2
a278 1
	memoryPointer -= sz + 2;
d282 2
a283 2
	memoryPointer->size =  sz << 2;
	return memoryPointer;
d294 2
a295 1
	staticPointer -= sz + 2;
d300 1
a300 1
	return staticPointer;
d318 1
a318 1
# ifndef gcalloc
d324 2
a325 1
	memoryPointer -= sz + 2;
d329 2
a330 2
	memoryPointer->size =  sz << 2;
	return memoryPointer;
@


1.11
log
@Get image format right for writing out images
@
text
@d160 3
a162 2
				memoryPointer -= (sz + 2);
				new_address = (struct mobject *) memoryPointer;
d179 3
a181 2
				memoryPointer -= (sz + 2);
				new_address = (struct mobject *) memoryPointer;
@


1.10
log
@Round #2 of new SmallInt encoding: tightening up range checking
and conversion to Integer.
@
text
@d390 1
a390 1
			fread(&val, sizeof(val), 1, fp);
d477 2
d480 2
a481 1
		writeWord(fp, integerValue(obj));
d542 1
@


1.9
log
@Implement SmallInt's as pseudo-objects.  They are 31-bit
signed quantities; the object pointer's low bit is set to 1
to flag a SmallInt as opposed to a true memory-based object
pointer.
@
text
@d387 6
a392 2
			size = readWord(fp);
			newObj = newInteger(size);
@


1.8
log
@Add new base class Integer
@
text
@d115 10
d129 2
a130 1
			if ((old_address >= (struct mobject *) memoryBase)
a134 1
			}
d137 1
a137 1
			if ((old_address < (struct mobject *) oldBase) ||
d291 1
a291 1
	if (staticPointer < staticBase)
d293 1
d353 1
a353 1
	if (i == EOF)
d355 2
a356 1
	if (i == 255)
d358 1
a358 1
	else
d360 1
a367 1
	struct integerObject *inewObj;
d388 1
a388 5
			newObj = staticIAllocate(BytesPerWord);
			indirArray[indirtop++] = newObj;
			inewObj = (struct integerObject *) newObj;
			inewObj->class = objectRead(fp);
			inewObj->value = size;
a430 3
	for (i = 0; i < 10; i++) {
		smallInts[i] = objectRead(fp);
	}
d464 1
a464 1
objectWrite(FILE * fp, struct object * obj)
d472 6
a493 7
	if (obj->class == SmallIntClass) { /* integer */
		writeWord(fp, 2);
		writeWord(fp, integerValue(obj));
		objectWrite(fp, obj->class);
		return;
	}

a530 3
	for (i = 0; i < 10; i++) {
		objectWrite(fp, smallInts[i]);
	}
@


1.7
log
@Fix cache flush for case just post-GC where stale cache entries
are not in current space, and isDynamic was saying they were thus
not dynamic memory (thus cache flushing didn't flush them, thus stale
entries remained in the cache).
@
text
@d430 1
@


1.6
log
@Indentation
@
text
@d53 2
a54 5
	if (inSpaceOne) {
		return ((x >= spaceOne) && (x <= (spaceOne + spaceSize)));
	} else {
		return ((x >= spaceTwo) && (x <= (spaceTwo + spaceSize)));
	}
@


1.5
log
@Indentation
@
text
@d111 15
a125 10
		/* part 1.  Walking down the tree
			keep stacking objects to be moved until we find
			one that we can handle */
		while (1) {
		/* if we find a pointer in the current space
			to the new space (other than indirections) then
			something is very wrong */
		if ((old_address >= (struct mobject *) memoryBase)
			&& (old_address <= (struct mobject *) memoryTop)) {
			sysError("GC invariant failure -- address in new space",
d128 2
a129 1
				/* else see if not  in old space */
d131 1
a131 1
					(old_address > (struct mobject *) oldTop)) {
d135 3
a137 3
			}
				/* else see if already forwarded */
			else if (old_address->size & 01)  {
d146 5
a150 3
			}
				/* else see if binary object */
			else if (old_address->size & 02) {int isz;
d157 2
a158 1
					new_address->data[sz] = old_address->data[sz];
d160 1
a160 1
					}
d167 3
a169 3
			}
				/* must be non-binary object */
			else  {
d182 11
a192 9
		/* part 2.  Fix up pointers,
			move back up tree as long as possible
			old_address points to an object in the old space,
			which in turns points to an object in the new space,
			which holds a pointer that is now to be replaced.
			the value in replacement is the new value */

		while (1) {
			if (old_address == 0) { /* backed out entirely */
d195 2
a196 1
				/* case 1, binary or last value */
d198 3
a200 2
				((old_address->size>>2) == 0)) {
					/* fix up class pointer */
d213 4
a216 2
					/* quick cheat for recovering
						zero fields */
@


1.4
log
@Centralize handling of static root table.
Defend against redundant registrations.
@
text
@d20 1
a20 3
static struct object * staticBase;
static struct object * staticTop;
static struct object * staticPointer;
d27 1
a27 2
static struct object * spaceOne;
static struct object * spaceTwo;
d30 1
a30 3
struct object * memoryBase;
struct object * memoryPointer;
struct object * memoryTop;
d33 1
a33 2
static struct object * oldBase;
static struct object * oldTop;
d50 2
a51 1
int isDynamicMemory(struct object * x)
d53 1
a53 1
	if (inSpaceOne)
d55 1
a55 1
	else
d57 1
d63 2
a64 1
void gcinit(int staticsz, int dynamicsz)
d102 2
a103 1
static struct object * gc_move(struct mobject * ptr)
d220 2
a221 1
struct object * gcollect(int sz)
d265 2
a266 1
struct object * staticAllocate(int sz)
d275 2
a276 1
struct object * staticIAllocate(int sz)
d291 4
a294 2
struct object * gcalloc(int sz)
{	struct object * result;
d299 1
a299 1
		}
d305 2
a306 1
struct object * gcialloc(int sz)
d322 1
a322 1
struct object * * indirArray;
d324 2
a325 1
unsigned int readWord(FILE * fp)
d328 1
d396 4
a399 2
int fileIn(FILE * fp)
{	int i;
d401 1
a401 1
		/* use the currently unused space for the indir pointers */
d404 1
a404 2
		}
	else {
d406 1
a406 1
		}
d413 1
a413 1
		}
d424 1
a424 1
		}
d431 2
a432 1
static void writeWord(FILE * fp, int i)
d434 1
a434 1
	if (i < 0)
d436 1
d440 1
a440 2
		}
	else
d442 1
d445 4
a448 4
static void objectWrite(FILE * fp, struct object * obj)
{	int i;
	int size;

d452 1
a452 1
		}
d454 2
a455 2
			/* see if already written */
	for (i = 0; i < indirtop; i++)
d457 1
a457 1
			if (i == 0)
d459 1
a459 1
			else {
d462 1
a462 1
				}
d464 2
a465 1
			}
d467 1
a467 1
		/* not written, do it now */
d475 1
a475 1
		}
d477 2
a478 1
	if (obj->size & 02) {	/* byte objects */
d487 1
a487 1
		}
d489 1
a489 1
		/* ordinary objects */
d494 1
a494 1
	for (i = 0; i < size; i++)
d496 1
d499 4
a502 2
int fileOut(FILE * fp)
{	int i;
d504 1
a504 1
		/* use the currently unused space for the indir pointers */
d507 1
a507 2
		}
	else {
d509 1
a509 1
		}
d516 1
a516 1
		}
d527 1
a527 1
		}
@


1.3
log
@Indentation tidy-up
@
text
@d45 1
a45 1
struct object * rootStack[ROOTSTACKLIMIT];
d47 3
a49 2
struct object * * staticRoots[STATICROOTLIMIT];
int staticRootTop = 0;
d103 1
a103 1
	};
d107 3
a109 5
	register struct mobject * old_address = ptr;
	struct mobject * previous_object = 0;
	struct mobject * new_address = 0;
	struct mobject * replacement  = 0;
	register int sz;
d134 1
a134 1
				if (old_address->size & 02)
d136 1
a136 1
				else {
d139 1
a139 1
					}
d183 1
a183 1
			if (old_address == 0)  /* backed out entirely */
d185 1
d196 1
a196 2
			}
			else {
d204 1
a204 1
				while (sz && (old_address->data[sz] == 0))
d206 1
a214 1

d223 2
a224 1
{	register int i;
d520 26
@


1.2
log
@Fix -Wall
@
text
@d124 1
a124 1
					(int)old_address);
d232 1
a232 2
		}
	else {
d236 1
a236 1
		}
d244 1
a244 1
		}
d248 1
a248 1
		}
d256 1
a256 1
		}
@


1.1
log
@Initial revision
@
text
@d11 1
d13 1
d69 1
a69 1
	staticBase = (struct object *) 
d71 1
a71 1
	spaceOne = (struct object *) 
d73 1
a73 1
	spaceTwo = (struct object *) 
d75 1
a75 1
	if ((staticBase == 0) || (spaceOne == 0) || (spaceTwo == 0)) 
d84 6
a89 4
	if (debugging)
		printf("space one %d, top %d , space two %d , top %d \n", 
			spaceOne, spaceOne + spaceSize, 
			spaceTwo, spaceTwo + spaceSize);
d118 1
a118 1
		/* if we find a pointer in the current space 
d121 1
a121 1
		if ((old_address >= (struct mobject *) memoryBase) 
d124 1
a124 1
					old_address);
d127 1
a127 1
			if ((old_address < (struct mobject *) oldBase) || 
d176 1
a176 1
		/* part 2.  Fix up pointers, 
d203 1
a203 1
					/* quick cheat for recovering 
d299 1
a299 1
	return memoryPointer; 
d333 2
a334 1
static struct object * objectRead(FILE * fp)
d336 4
a339 6
	int type;
	int size;
	int i;
	struct object * newObj;
	struct integerObject * inewObj;
	struct byteObject * bnewObj;
d343 1
a343 1
	switch(type) {
d345 1
a345 1
			sysError("read in a null object", newObj);
d443 1
a443 1
		sysError("writing out a null object", obj);
@
