head	1.10;
access;
symbols
	V1_6_7:1.10;
locks; strict;
comment	@ * @;


1.10
date	2001.05.29.01.14.08;	author vandys;	state Exp;
branches;
next	1.9;

1.9
date	2001.05.29.00.28.20;	author vandys;	state Exp;
branches;
next	1.8;

1.8
date	2001.05.08.06.46.25;	author vandys;	state Exp;
branches;
next	1.7;

1.7
date	2001.05.05.05.22.10;	author vandys;	state Exp;
branches;
next	1.6;

1.6
date	2001.03.16.10.32.29;	author vandys;	state Exp;
branches;
next	1.5;

1.5
date	2001.03.07.23.15.08;	author vandys;	state Exp;
branches;
next	1.4;

1.4
date	2001.03.07.21.47.49;	author vandys;	state Exp;
branches;
next	1.3;

1.3
date	2001.03.03.15.38.10;	author vandys;	state Exp;
branches;
next	1.2;

1.2
date	2001.02.26.21.06.46;	author vandys;	state Exp;
branches;
next	1.1;

1.1
date	2001.02.10.15.34.12;	author vandys;	state Exp;
branches;
next	;


desc
@@


1.10
log
@Convert missing method to a call to doesNotUnderstand:
This creates the possibility of intercepting this message by a debugger
or proxy object.
@
text
@/*
	memory management for the Little Smalltalk system
	Uses a variation on the Baker two-space algorithm

	Written by Tim Budd, Oregon State University, 1994
	Comments to budd@@cs.orst.edu
	All rights reserved, no guarantees given whatsoever.
	May be freely redistributed if not for profit.
*/

/*
	The fundamental data type is the object.
	The first field in an object is a size, the low order two
		bits being used to maintain:
			* binary flag, used if data is binary
			* indirection flag, used if object has been relocated
	The next data field is the class
	The following fields are either objects, or character values

	The initial image is loaded into static memory space --
	space which is never garbage collected
	This improves speed, as these items are not moved during GC
*/
#include <sys/types.h>

struct object {
	uint size;
	struct object *class;
	struct object *data[0];
};

/*
	byte objects are used to represent strings and symbols
		bytes per word must be correct
*/

struct byteObject {
	uint size;
	struct object *class;
	unsigned char bytes[0];
};

# define BytesPerWord 4
# define bytePtr(x) (((struct byteObject *) x)->bytes)
#define WORDSUP(ptr, amt) ((struct object *)(((char *)(ptr)) + \
	((amt) * BytesPerWord)))
#define WORDSDOWN(ptr, amt) WORDSUP(ptr, 0 - (amt))

/*
 * SmallInt objects are used to represent short integers.  They are
 * encoded as 31 bits, signed, with the low bit set to 1.  This
 * distinguishes them from all other objects, which are longword
 * aligned and are proper C memory pointers.
 */
#include <limits.h>

#define IS_SMALLINT(x) ((((int)(x)) & 0x01) != 0)
#define FITS_SMALLINT(x) ((((int)(x)) >= INT_MIN/2) && \
	(((int)(x)) <= INT_MAX/2))
#define CLASS(x) (IS_SMALLINT(x) ? SmallIntClass : ((x)->class))
#define integerValue(x) (((int)(x)) >> 1)
#define newInteger(x) ((struct object *)((((int)(x)) << 1) | 0x01))

/*
 * The "size" field is the top 30 bits; the bottom two are flags
 */
#define SIZE(op) ((op)->size >> 2)
#define SETSIZE(op, val) ((op)->size = ((val) << 2))
#define FLAG_GCDONE (0x01)
#define FLAG_BIN (0x02)

/*
	memoryBase holds the pointer to the current space,
	memoryPointer is the pointer into this space.
	To allocate, decrement memoryPointer by the correct amount.
	If the result is less than memoryBase, then garbage collection
	must take place

*/

extern struct object *memoryPointer, *memoryBase;

/*
	roots for the memory space
	these are traced down during memory management
	rootStack is the dynamic stack
	staticRoots are values in static memory that point to
	dynamic values
*/
# define ROOTSTACKLIMIT 50
extern struct object *rootStack[];
extern int rootTop;
extern void addStaticRoot(struct object **);

/*
	The following are roots for the file out 
*/

extern struct object *nilObject, *trueObject,
	*falseObject, *SmallIntClass, *ArrayClass, *BlockClass,
	*ContextClass, *globalsObject, *initialMethod,
	*binaryMessages[3], *IntegerClass, *badMethodSym;

/*
	entry points
*/

extern void gcinit(int, int);
extern struct object *gcollect(int), *staticAllocate(int),
	*staticIAllocate(int), *gcialloc(int);
extern void exchangeObjects(struct object *, struct object *, uint);

extern int isDynamicMemory(struct object *);

#define gcalloc(sz) (((memoryPointer = WORDSDOWN(memoryPointer, (sz) + 2)) < \
	memoryBase) ? gcollect(sz) : \
	(SETSIZE(memoryPointer, (sz)), memoryPointer))

#ifndef gcalloc
extern struct object *gcalloc(int);
#endif
@


1.9
log
@Implement become:
Also tidy up some pointer arithmetic idioms using a macro
@
text
@d102 1
a102 1
	*binaryMessages[3], *IntegerClass;
@


1.8
log
@Parameterize use of object "size" field
@
text
@d45 3
d111 1
d115 2
a116 3
#define gcalloc(sz) (((memoryPointer = \
	(struct object *)(((uint *)memoryPointer) - ((sz) + 2))) < \
	memoryBase) ?  gcollect(sz) : \
@


1.7
log
@Indentation
@
text
@d24 1
d27 4
a30 4
	int size;
	struct object * class;
	struct object * data [0];
	};
d38 1
a38 1
	int size;
d41 1
a41 1
	};
d62 8
d114 1
a114 1
	(memoryPointer->size = (sz) << 2, memoryPointer))
@


1.6
log
@Fix pointer arithmetic error, where object sizes were being scaled
by sizeof(struct object), wasting a lot of memory.
@
text
@d69 1
a69 2
extern struct object * memoryPointer;
extern struct object * memoryBase;
d79 1
a79 1
extern struct object * rootStack[];
d106 1
@


1.5
log
@Round #2 of new SmallInt encoding: tightening up range checking
and conversion to Integer.
@
text
@d103 7
a109 5
# define gcalloc(sz) (((memoryPointer-=(sz+1))<memoryBase)?\
	gcollect(sz):(memoryPointer->size=sz<<2,memoryPointer))
# ifndef gcalloc
extern struct object * gcalloc(int);
# endif
@


1.4
log
@Implement SmallInt's as pseudo-objects.  They are 31-bit
signed quantities; the object pointer's low bit is set to 1
to flag a SmallInt as opposed to a true memory-based object
pointer.
@
text
@d51 5
a55 1
#define IS_SMALLINT(x) ((((int)x) & 0x01) != 0)
d57 2
a58 2
#define integerValue(x) (((int)x) >> 1)
#define newInteger(x) ((struct object *)((((int)x) << 1) | 0x01))
@


1.3
log
@Add new base class Integer
@
text
@d46 9
a54 10
	integer objects are used to represent short integers
*/

struct integerObject {
	int size;
	struct object * class;
	unsigned int value;
	};

# define integerValue(x) (((struct integerObject *) x)->value)
d84 1
a84 1
extern struct object *nilObject, *smallInts[10], *trueObject,
@


1.2
log
@Centralize handling of static root table.
Defend against redundant registrations.
@
text
@d85 4
a88 11
extern struct object * nilObject;
extern struct object * smallInts[10];
extern struct object * trueObject;
extern struct object * falseObject;
extern struct object * SmallIntClass;
extern struct object * ArrayClass;
extern struct object * BlockClass;
extern struct object * ContextClass;
extern struct object * globalsObject;
extern struct object * initialMethod;
extern struct object * binaryMessages[3];
d94 3
a96 5
void gcinit(int, int);
struct object * gcollect(int);
struct object * staticAllocate(int);
struct object * staticIAllocate(int);
struct object * gcialloc(int);
d98 1
a98 1
int isDynamicMemory(struct object *);
@


1.1
log
@Initial revision
@
text
@d79 1
a79 3
# define STATICROOTLIMIT 200
extern struct object * * staticRoots[];
extern int staticRootTop;
@
